#ifndef MESHNODE_H
#define MESHNODE_H

#include "scenenode.h"
#include "glm/mat4x4.hpp"
#include "scene.h"

/**
 * @brief The MeshNode class holds a mesh
 */

class MeshNode : public SceneNode
{
    GeometryNode geometry;
public:
    // temp
    glm::mat4 m_movement;
    glm::mat4 m_acceleration;

    MeshNode(Mesh* mesh) : geometry(mesh, glm::mat4()) {}

    virtual void update()
    {
        m_movement = m_acceleration * m_movement;
        geometry.modelMatrix = m_movement * geometry.modelMatrix;
    }

    void setSceneTree(SceneTree *tree);

    void setTransform(const glm::mat4 &transform) { geometry.modelMatrix = transform; }
    const glm::mat4& getTransform() { return geometry.modelMatrix; }
    void setDepth(float depth);

    GeometryNode* getGeometryNode() { return &geometry; }
};

#endif // MESHNODE_H
