#ifndef SPARROWSHELL_H
#define SPARROWSHELL_H

#include <list>

#include "system.h"
#include "scene/scenetree.h"
#include "glm/glm.hpp"

class Input;
class MeshNode;

namespace sf {
class Window;
}

class SparrowShell : public ContainerNode
{
private:
    //class BackGround : public MeshNode {

//    };

    class ScrollBar{
        SparrowShell* m_shell;
        glm::ivec2 m_position;
        glm::ivec2 m_dimension;
        MeshNode *m_mesh;
        //TODO : Add rectangle mesh

    public:
        ScrollBar(){}
        ScrollBar(SparrowShell* shell);
        void update();
    };

    class ShellBuffer{
    private:
        std::vector<std::string> m_buffer;
        int m_zero_offset = 0;
        unsigned int m_size;
    public:
        ShellBuffer(int size):m_size(size){}
        std::string& operator[](int i){return m_buffer[(m_zero_offset+i)%m_size];}
        void push(std::string);
        unsigned int size(){return m_size;}
    };

    static const unsigned int BUFFER_MAX_LENGTH;
    static const unsigned int BUFFER_DISPLAYED_NUMBER;
    static const unsigned int SCROLLBAR_PIXEL_WIDTH;
    static const float SHELL_DEPTH;

    sf::Window* m_window;
    Input* m_input;
    SceneTree* m_currentScene;

    glm::ivec2 m_position;
    glm::ivec2 m_dimension;
    std::vector<MeshNode*> m_textMeshes;
    ShellBuffer m_buffer;
    int m_index = 0;
    bool m_resizeScrollBar = false;
    bool m_indexMoved = false;
    //textMesh
    MeshNode* m_background;
    ScrollBar m_scrollbar;

public:
    SparrowShell(sf::Window*, Input*);

    void update();
    void setScene(SceneTree *scene){m_currentScene = scene;}

    void scrollUp();
    void scrollDown();
    void out(std::string);
};

#endif // SPARROWSHELL_H
