#include <engine.h>
#include <input.h>
#include <scene.h>
#include <mesh.h>
#include <deferredpipeline.h>
#include <phongmaterial.h>
#include <resourcemanager.h>
#include <sparrowrenderer.h>
#include <texture.h>


#include <scene/scenetree.h>
#include <tools/graph.h>
#include <tools/pathfinder.h>
#include <tools/loader.h>

#include <tools/font.h>
#include <tools/utils.h>

#include <sparrowshell.h>

int main(){
    Engine engine;

    // this creates the opengl context
    // the opengl context must exist before any opengl class is used (texture, pipeline, etc..)
    engine.createWindow("test");
    SceneTree scene;

    /* Exemple creation mesh 2D
     *
    Mesh* mesh = new Mesh();
    mesh->addRectangle2D(180, 400,10,64);
    PhongMaterial *mat = new PhongMaterial();
    mat->diffuse = glm::vec3(1, 0.5, 0);
    mesh->setMaterial(mat);
    mesh->setDepth(1);
    mesh->initGL();
    scene.addObject(scene.getRootObject(),new MeshNode(mesh));
 */

/* Exemple ajout d'un objet a la scene
 *
   SparrowShell *shell = new SparrowShell(engine.getWindow(),engine.getInput());
   scene.addObject(scene.getRootObject(),shell);
*/

    // the pipeline needs to updates his shaders because the scene changed
    // this should be handled somewhere else in the future
    //DeferredPipeline* pipeline = (DeferredPipeline*)scene.getPipeline();
    //pipeline->refreshScene(&scene);

    Font* fonte_des_neiges = Loader::loadFont("../data/consolas.fnt","../data/consolas.png");
    RESOURCE_ADD(fonte_des_neiges,Font,"shellfont");

    TextNode* tnode/* = new MeshNode(fonte_des_neiges->getTextMesh("Hello World!"));
    scene.addObject(scene.getRootObject(),mnode)*/;

//    mnode = new MeshNode(fonte_des_neiges->getTextMesh("Portez ce vieux whisky au juge blond qui fume.", glm::vec3(0.5, 0.7, 0.2)));
//    mnode->setTransform(glm::rotate(glm::translate(glm::mat4(), glm::vec3(70, 30, 0)), 0.4f, glm::vec3(0, 0, 1)));
//    utils::setPosition2D(mnode,glm::vec2(0, 400));
 //   utils::rotate2D(mnode, glm::vec2(10,10),0.5);
//    scene.addObject(scene.getRootObject(),mnode);

    tnode = fonte_des_neiges->getTextNode("Such Text", glm::vec3(0.7, 0.4, 0.2));

    utils::setPosition2D((MeshNode*)tnode,glm::vec2(200, 170));
    utils::rotate2D((MeshNode*)tnode, glm::vec2(0),-0.5);

    // mnode->setTransform(glm::rotate(glm::translate(glm::mat4(), glm::vec3(200, 170, 0)), -0.5f, glm::vec3(0, 0, 1)));
    scene.addObject(scene.getRootObject(),(SceneNode*)tnode);
    
    //tnode = fonte_des_neiges->getTextNode("Such Text", glm::vec3(0.7, 0.4, 0.2));
    //tnode->setTransform(glm::rotate(glm::translate(glm::mat4(), glm::vec3(200, 170, 0)), -0.5f, glm::vec3(0, 0, 1)));
    //scene.addObject(scene.getRootObject(),tnode);


  //  mnode = new MeshNode(fonte_des_neiges->getTextMesh("Very font", glm::vec3(0.7, 0.2, 0.8)));
  //  mnode->setTransform(glm::rotate(glm::translate(glm::mat4(), glm::vec3(180, 400, 0)), 0.1f, glm::vec3(0, 0, 1)));
  //  scene.addObject(scene.getRootObject(),mnode);
    
   // mnode = new MeshNode(fonte_des_neiges->getTextMesh("Much animation", glm::vec3(0.3, 0.3, 0.8)));
   // mnode->setTransform(glm::translate(glm::mat4(), glm::vec3(400, 250, 0)));
   // mnode->m_movement = glm::translate(glm::rotate(glm::translate(glm::mat4(), glm::vec3(580, 280, 0)), 0.03f, glm::vec3(0, 0, 1)), glm::vec3(-580, -280, 0));
   // scene.addObject(scene.getRootObject(),mnode);

    engine.outputShell("Hello World!");
    engine.outputShell("Starting test :");

    for(int i = 0; i < 23; i++){
        engine.outputShell(std::to_string(i));
    }

    engine.setScene(&scene);
    engine.start();

  /*  GraphNode n1 = GraphNode();
    n1.setValue(1);
    GraphNode n2 = GraphNode();
    n2.setValue(2);
    GraphNode n3 = GraphNode();
    n3.setValue(3);
    GraphNode n4 = GraphNode();
    n4.setValue(4);
    GraphNode n5 = GraphNode();
    n5.setValue(5);

    n1.addNeighbours(&n2);
    n1.addNeighbours(&n3);
    n2.addNeighbours(&n4);
    n3.addNeighbours(&n4);
    n3.addNeighbours(&n2);
    n3.addNeighbours(&n5);

    std::vector<GraphNode*> path = PathFinder::a_star(&n1,&n4,true);
    std::cout << "Path Size: " << path.size() << std::endl;
    for(GraphNode* gn: path){
        std::cout << gn->getValue() << std::endl;
    }

    Loader::setObjDirectory("../data/");
    Loader::setMtlDirectory("../data/");
    Loader::setTexDirectory("../data/");
    std::vector<Mesh*> meshes = Loader::loadMesh("sword.obj");
*/



}
